/* define ID of this brick */
#define ID 2

/* include time.h */
#include <time.h>
/* include conio.h */
#include <conio.h>

/* include com.c */
#include "com.c"

/* declare thread id for read_from_ir_thread */
tid_t read_from_ir_thread;
/* declare thread id for send_to_ir_thread */
tid_t received_thread;

/* begin wait function have */
static wakeup_t have(wakeup_t w) {
    /* return TRIGGER1 */
    return TRIGGER1;
/* end wait function have*/
}

/* begin received thread */
int received(int argc, char *argv[]) {

    /* declare a */
    int a;
    /* initialize a */
    a=1;
    
    /* begin while loop */
    while(!shutdown_requested()) {
        /* wait for funcion have */
        wait_event(have,0);
        /* show TRIGGER1 on lcd */
        lcd_int(TRIGGER1);
        /* wait for semaphore key */
        sem_wait(&sem_com);
        /* set TRIGGER1 to zero */
        TRIGGER1=0;
        /* post semaphore key */
        sem_post(&sem_com);
        /* sleep 0.01 seconds */
        msleep(10);
        /* send "a" from RCX ID to RCX 1 with type 2 */
        com_send(ID,1,2,&a);
    /* end while loop */
    }

    /* return 0 */
    return 0;
/* end received thread */
}

/* begin main */
int main(int argc, char *argv[]) {

    /* initialize communication port */
    lnp_integrity_set_handler(port_handler);
    /* set ir range to "far" */
    lnp_logical_range(1);
    /* initialize semaphore for communication */
    sem_init(&sem_com, 0, 1);

    /* start read_from_ir thread */
	read_from_ir_thread = execi(&read_from_ir,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);
    /* start received thread */
	received_thread = execi(&received,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);

	/* return 0 */
    return 0;
/* end main */
}
